
/*	
	This file is part of miSCellaneous, a program library for SuperCollider 3
	
	Created: 2013-05-05, version 0.8
	Copyright (C) 2009-2013 Daniel Mayer 
	Email: 	daniel-mayer@email.de
	URL:		www.daniel-mayer.at

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/





Pshufn : ListPattern {
	embedInStream { |inval|
		var item, stream;
		repeats.value(inval).do { |j|
			(0..(list.size-1)).scramble.do { |i|
				item = list.wrapAt(i);
				inval = item.embedInStream(inval);
			};
		};
		^inval;
	}
}

PlaceAll : Ppatlace {
	*new { |list, repeats = 1, offset = 0|
		var laceList = list.miSC_makeLaceList;
		^super.new(laceList, repeats, offset);
		
	}
}


Pstream : Plazy { 
	var <>src, <>length, <>srcStream, <>lengthStream;
	*new { |src, length| 
		var lengthStream = length.asStream, srcStream = src.asStream; 
		^super.new.func_({ |inval| 
			Pfinval(lengthStream.next(inval), Pfunc { srcStream.next(inval) }) })
			.src_(src).length_(length).srcStream_(srcStream)
			.lengthStream_(lengthStream)  
	} 
} 

